/*
   This code is from "Algorithms in Java, Third Edition,"
   by Robert Sedgewick, Addison-Wesley, 2003.
*/

#define exch(A, B) { int t = A; A = B; B = t; }

// Programs 7.1, 7.2, page 317, 319
void quicksort(int a[], int l, int r)
{
   if (r <= l)
   {
      return;
   }
   else
   {
      int v = a[r];
      int i = l-1, j = r;
      for (;;)
      {
         while (a[++i] < v) ;
         while (v < a[--j]) if (j == l) break;
         if (i >= j) break;
         exch(a[i], a[j]);
      }
      exch(a[i], a[r]);

      quicksort(a, l,   i-1);
      quicksort(a, i+1, r);
   }
}
